Index: c/src/ada-tests/ChangeLog
===================================================================
--- c/src/ada-tests/ChangeLog	(revision d14963bf948d6e7b9250cc077f86c18e6458b478)
+++ c/src/ada-tests/ChangeLog	(revision ba3e1a4fafa6c5f1c1ad731d33c84e41ccba870b)
@@ -1,2 +1,42 @@
+2007-10-10	Glenn Humphrey <glenn.humphrey@OARcorp.com>
+
+	* configure.ac, samples/base_sp/base_sp.scn, samples/base_sp/config.h,
+	samples/base_sp/sptest.adb, samples/hello/config.h,
+	samples/ticker/config.h, samples/ticker/ticker.scn,
+	sptests/Makefile.am, sptests/sp01/sp01.scn, sptests/sp02/config.h,
+	sptests/sp02/sp02.scn, sptests/sp03/config.h, sptests/sp03/sp03.scn,
+	sptests/sp04/sp04.scn, sptests/sp04/sptest.adb,
+	sptests/sp05/config.h, sptests/sp05/sp05.scn, sptests/sp06/config.h,
+	sptests/sp07/config.h, sptests/sp07/sp07.scn,
+	sptests/sp07/sptest.adb, sptests/sp07/sptest.ads,
+	sptests/sp08/config.h, sptests/sp08/sp08.scn,
+	sptests/sp09/Makefile.am, sptests/sp09/config.h,
+	sptests/sp09/sp09.scn, sptests/sp09/sptest.adb,
+	sptests/sp09/sptest.ads, sptests/sp11/config.h,
+	sptests/sp11/sp11.scn, sptests/sp12/config.h, sptests/sp12/sp12.scn,
+	sptests/sp13/config.h, sptests/sp13/sp13.scn,
+	sptests/sp13/sptest.adb, sptests/sp14/config.h,
+	sptests/sp14/sp14.scn, sptests/sp15/config.h, sptests/sp15/sp15.scn,
+	sptests/sp16/config.h, sptests/sp16/sp16.scn,
+	sptests/sp16/sptest.adb, sptests/sp17/config.h,
+	sptests/sp19/config.h, sptests/sp19/sp19.scn, sptests/sp20/config.h,
+	sptests/sp20/sp20.scn, sptests/sp22/config.h, sptests/sp22/sp22.scn,
+	sptests/sp23/config.h, sptests/sp23/sp23.scn, sptests/sp24/config.h,
+	sptests/sp24/sp24.scn, sptests/sp25/config.h, sptests/sp25/sp25.scn,
+	support/init.c, support/test_support.adb, support/test_support.ads,
+	tmtests/tm09/config.h, tmtests/tm20/tmtest.adb,
+	tmtests/tmoverhd/dummy_rtems.adb, tmtests/tmoverhd/dummy_rtems.ads,
+	tmtests/tmoverhd/tmtest.adb, tmtests/tmoverhd/tmtest.ads: Updated
+	tests so that they would all compile and run without errors. Some
+	tests that are no longer valid using the current binding were
+	removed. Also updated the .scn files to reflect the current test
+	output.
+	* sptests/sp21/.cvsignore, sptests/sp21/Makefile.am,
+	sptests/sp21/config.h, sptests/sp21/sp21.adb, sptests/sp21/sp21.scn,
+	sptests/sp21/sptest.adb, sptests/sp21/sptest.ads,
+	sptests/spsize/.cvsignore, sptests/spsize/Makefile.am,
+	sptests/spsize/spsize.adb, sptests/spsize/sptest.adb,
+	sptests/spsize/sptest.ads: Removed.
+
 2007-10-03	Joel Sherrill <joel.sherrill@oarcorp.com>
 
Index: c/src/ada-tests/configure.ac
===================================================================
--- c/src/ada-tests/configure.ac	(revision d14963bf948d6e7b9250cc077f86c18e6458b478)
+++ c/src/ada-tests/configure.ac	(revision ba3e1a4fafa6c5f1c1ad731d33c84e41ccba870b)
@@ -74,10 +74,8 @@
 sptests/sp19/Makefile
 sptests/sp20/Makefile
-sptests/sp21/Makefile
 sptests/sp22/Makefile
 sptests/sp23/Makefile
 sptests/sp24/Makefile
 sptests/sp25/Makefile
-sptests/spsize/Makefile
 ])
 
Index: c/src/ada-tests/samples/base_sp/base_sp.scn
===================================================================
--- c/src/ada-tests/samples/base_sp/base_sp.scn	(revision d14963bf948d6e7b9250cc077f86c18e6458b478)
+++ c/src/ada-tests/samples/base_sp/base_sp.scn	(revision ba3e1a4fafa6c5f1c1ad731d33c84e41ccba870b)
@@ -1,4 +1,4 @@
 *** SAMPLE SINGLE PROCESSOR APPLICATION ***
 Creating and starting an application task
-Application task was invoked with argument (0) and has id of 0x10002
+Application task was invoked with argument (          0) and has id of 0x16#A010002#
 *** END OF SAMPLE SINGLE PROCESSOR APPLICATION ***
Index: c/src/ada-tests/samples/base_sp/config.h
===================================================================
--- c/src/ada-tests/samples/base_sp/config.h	(revision d14963bf948d6e7b9250cc077f86c18e6458b478)
+++ c/src/ada-tests/samples/base_sp/config.h	(revision ba3e1a4fafa6c5f1c1ad731d33c84e41ccba870b)
@@ -3,5 +3,5 @@
  *  This include file defines the Configuration Table for this test.
  *
- *  COPYRIGHT (c) 1989-1997.
+ *  COPYRIGHT (c) 1989-2007.
  *  On-Line Applications Research Corporation (OAR).
  *
@@ -28,4 +28,6 @@
 #define CONFIGURE_MAXIMUM_POSIX_CONDITION_VARIABLES  10
 
+#define CONFIGURE_MAXIMUM_TASKS            2
+
 #include <rtems/confdefs.h>
 
Index: c/src/ada-tests/samples/base_sp/sptest.adb
===================================================================
--- c/src/ada-tests/samples/base_sp/sptest.adb	(revision d14963bf948d6e7b9250cc077f86c18e6458b478)
+++ c/src/ada-tests/samples/base_sp/sptest.adb	(revision ba3e1a4fafa6c5f1c1ad731d33c84e41ccba870b)
@@ -88,4 +88,5 @@
       TEXT_IO.PUT( ") and has id of 0x" );
       UNSIGNED32_IO.PUT( TID, BASE => 16 );
+      TEXT_IO.NEW_LINE;
 
       TEXT_IO.PUT_LINE( "*** END OF SAMPLE SINGLE PROCESSOR APPLICATION ***" );
Index: c/src/ada-tests/samples/hello/config.h
===================================================================
--- c/src/ada-tests/samples/hello/config.h	(revision d14963bf948d6e7b9250cc077f86c18e6458b478)
+++ c/src/ada-tests/samples/hello/config.h	(revision ba3e1a4fafa6c5f1c1ad731d33c84e41ccba870b)
@@ -3,5 +3,5 @@
  *  This include file defines the Configuration Table for this test.
  *
- *  COPYRIGHT (c) 1989-1997.
+ *  COPYRIGHT (c) 1989-2007.
  *  On-Line Applications Research Corporation (OAR).
  *
@@ -22,6 +22,4 @@
 #define CONFIGURE_POSIX_INIT_THREAD_TABLE
 
-#define CONFIGURE_MAXIMUM_TASKS              2
-
 #define CONFIGURE_MAXIMUM_POSIX_THREADS              10
 #define CONFIGURE_MAXIMUM_POSIX_KEYS                 10
@@ -29,4 +27,6 @@
 #define CONFIGURE_MAXIMUM_POSIX_CONDITION_VARIABLES  10
 
+#define CONFIGURE_MAXIMUM_TASKS              1
+
 #include <rtems/confdefs.h>
 
Index: c/src/ada-tests/samples/ticker/config.h
===================================================================
--- c/src/ada-tests/samples/ticker/config.h	(revision d14963bf948d6e7b9250cc077f86c18e6458b478)
+++ c/src/ada-tests/samples/ticker/config.h	(revision ba3e1a4fafa6c5f1c1ad731d33c84e41ccba870b)
@@ -3,5 +3,5 @@
  *  This include file defines the Configuration Table for this test.
  *
- *  COPYRIGHT (c) 1989-1997.
+ *  COPYRIGHT (c) 1989-2007.
  *  On-Line Applications Research Corporation (OAR).
  *
@@ -28,4 +28,6 @@
 #define CONFIGURE_MAXIMUM_POSIX_CONDITION_VARIABLES  10
 
+#define CONFIGURE_MAXIMUM_TASKS             4
+
 #include <rtems/confdefs.h>
 
Index: c/src/ada-tests/samples/ticker/ticker.scn
===================================================================
--- c/src/ada-tests/samples/ticker/ticker.scn	(revision d14963bf948d6e7b9250cc077f86c18e6458b478)
+++ c/src/ada-tests/samples/ticker/ticker.scn	(revision ba3e1a4fafa6c5f1c1ad731d33c84e41ccba870b)
@@ -1,3 +1,3 @@
-*** CLOCK TICK TEST ***
+*** TEST 1 ***
 TA1 - clock_get -  9: 0: 0   12/31/1988
 TA2 - clock_get -  9: 0: 0   12/31/1988
@@ -6,11 +6,11 @@
 TA2 - clock_get -  9: 0:10   12/31/1988
 TA1 - clock_get -  9: 0:10   12/31/1988
+TA3 - clock_get -  9: 0:15   12/31/1988
 TA1 - clock_get -  9: 0:15   12/31/1988
-TA3 - clock_get -  9: 0:15   12/31/1988
 TA2 - clock_get -  9: 0:20   12/31/1988
 TA1 - clock_get -  9: 0:20   12/31/1988
 TA1 - clock_get -  9: 0:25   12/31/1988
+TA3 - clock_get -  9: 0:30   12/31/1988
+TA1 - clock_get -  9: 0:30   12/31/1988
 TA2 - clock_get -  9: 0:30   12/31/1988
-TA1 - clock_get -  9: 0:30   12/31/1988
-TA3 - clock_get -  9: 0:30   12/31/1988
 *** END OF CLOCK TICK TEST ***
Index: c/src/ada-tests/sptests/Makefile.am
===================================================================
--- c/src/ada-tests/sptests/Makefile.am	(revision d14963bf948d6e7b9250cc077f86c18e6458b478)
+++ c/src/ada-tests/sptests/Makefile.am	(revision ba3e1a4fafa6c5f1c1ad731d33c84e41ccba870b)
@@ -20,10 +20,8 @@
 SUBDIRS += sp19
 SUBDIRS += sp20
-SUBDIRS += sp21
 SUBDIRS += sp22
 SUBDIRS += sp23
 SUBDIRS += sp24
 SUBDIRS += sp25
-SUBDIRS += spsize
 
 include $(top_srcdir)/../../../testsuites/automake/subdirs.am
Index: c/src/ada-tests/sptests/sp02/config.h
===================================================================
--- c/src/ada-tests/sptests/sp02/config.h	(revision d14963bf948d6e7b9250cc077f86c18e6458b478)
+++ c/src/ada-tests/sptests/sp02/config.h	(revision ba3e1a4fafa6c5f1c1ad731d33c84e41ccba870b)
@@ -3,5 +3,5 @@
  *  This include file defines the Configuration Table for this test.
  *
- *  COPYRIGHT (c) 1989-1997.
+ *  COPYRIGHT (c) 1989-2007.
  *  On-Line Applications Research Corporation (OAR).
  *
@@ -28,4 +28,6 @@
 #define CONFIGURE_MAXIMUM_POSIX_CONDITION_VARIABLES  10
 
+#define CONFIGURE_MAXIMUM_TASKS             4
+
 #include <rtems/confdefs.h>
 
Index: c/src/ada-tests/sptests/sp02/sp02.scn
===================================================================
--- c/src/ada-tests/sptests/sp02/sp02.scn	(revision d14963bf948d6e7b9250cc077f86c18e6458b478)
+++ c/src/ada-tests/sptests/sp02/sp02.scn	(revision ba3e1a4fafa6c5f1c1ad731d33c84e41ccba870b)
@@ -6,6 +6,6 @@
 TA2 - task_wake_after - sleep 1 minute
 TA3 - task_wake_after - sleep 5 seconds
-TA1 - task_ident - tid of TA2 (16#10007#)
-TA1 - task_ident - tid of TA3 (16#10008#)
+TA1 - task_ident - tid of TA2 (16#A010004#)
+TA1 - task_ident - tid of TA3 (16#A010002#)
 TA1 - task_set_priority - set TA3's priority to 2
 TA1 - task_suspend - suspend TA2
Index: c/src/ada-tests/sptests/sp03/config.h
===================================================================
--- c/src/ada-tests/sptests/sp03/config.h	(revision d14963bf948d6e7b9250cc077f86c18e6458b478)
+++ c/src/ada-tests/sptests/sp03/config.h	(revision ba3e1a4fafa6c5f1c1ad731d33c84e41ccba870b)
@@ -3,5 +3,5 @@
  *  This include file defines the Configuration Table for this test.
  *
- *  COPYRIGHT (c) 1989-1997.
+ *  COPYRIGHT (c) 1989-2007.
  *  On-Line Applications Research Corporation (OAR).
  *
@@ -28,4 +28,6 @@
 #define CONFIGURE_MAXIMUM_POSIX_CONDITION_VARIABLES  10
 
+#define CONFIGURE_MAXIMUM_TASKS             3
+
 #include <rtems/confdefs.h>
 
Index: c/src/ada-tests/sptests/sp04/sp04.scn
===================================================================
--- c/src/ada-tests/sptests/sp04/sp04.scn	(revision d14963bf948d6e7b9250cc077f86c18e6458b478)
+++ c/src/ada-tests/sptests/sp04/sp04.scn	(revision ba3e1a4fafa6c5f1c1ad731d33c84e41ccba870b)
@@ -1,4 +1,3 @@
 *** TEST 4 ***
-TA1 -  9:15: 0   12/31/1988
 TA1 - task_suspend - on Task 2
 TA1 - task_suspend - on Task 3
@@ -6,10 +5,4 @@
 TA1 - task_resume - on Task 2
 TA1 - task_resume - on Task 3
-TA2 -  9:15: 4   12/31/1988
-TA3 -  9:15: 5   12/31/1988
-TA1 -  9:15: 6   12/31/1988
-TA2 -  9:15: 7   12/31/1988
-TA3 -  9:15: 8   12/31/1988
-TA1 -  9:15: 9   12/31/1988
 TA1 - task_mode - change mode to NO PREEMPT
 TA1 -  9:15:10   12/31/1988
@@ -20,4 +13,13 @@
 TA1 -  9:15:15   12/31/1988
 TA1 - task_mode - change mode to PREEMPT
+TA1 -  9:15: 0   12/31/1988
+TA2 -  9:15: 4   12/31/1988
+TA3 -  9:15: 5   12/31/1988
+TA1 -  9:15: 6   12/31/1988
+TA2 -  9:15: 7   12/31/1988
+TA3 -  9:15: 8   12/31/1988
+TA1 -  9:15: 9   12/31/1988
 TA2 -  9:15:16   12/31/1988
+TA3 -  9:15:17   12/31/1988
+TA1 -  9:15:18   12/31/1988
 *** END OF TEST 4 ***
Index: c/src/ada-tests/sptests/sp04/sptest.adb
===================================================================
--- c/src/ada-tests/sptests/sp04/sptest.adb	(revision d14963bf948d6e7b9250cc077f86c18e6458b478)
+++ c/src/ada-tests/sptests/sp04/sptest.adb	(revision ba3e1a4fafa6c5f1c1ad731d33c84e41ccba870b)
@@ -11,5 +11,5 @@
 --  
 --
---  COPYRIGHT (c) 1989-1997.
+--  COPYRIGHT (c) 1989-2007.
 --  On-Line Applications Research Corporation (OAR).
 --
@@ -27,4 +27,43 @@
 
 package body SPTEST is
+
+   TestsFinished : Boolean := False;
+   pragma Volatile (TestsFinished);
+
+   type Task_Event is record
+      Task_Index    : RTEMS.Unsigned32;
+      When_Switched : RTEMS.Time_Of_Day;
+   end record;
+
+   Task_Events : array (1 .. 15) of Task_Event;
+   Task_Events_Index : Natural := Task_Events'First;
+
+   procedure Log_Task_Event (
+      Task_Index    : RTEMS.Unsigned32;
+      When_Switched : RTEMS.Time_Of_Day
+   ) is
+   begin
+      if Task_Events_Index = Task_Events'Last then
+         RTEMS.Fatal_Error_Occurred ( 1 );  -- no other choice
+      else
+         Task_Events (Task_Events_Index).Task_Index := Task_Index;
+         Task_Events (Task_Events_Index).When_Switched := When_Switched;
+         Task_Events_Index := Task_Events_Index + 1;
+      end if;
+   end Log_Task_Event;
+
+   procedure Flush_Task_Event_Log is
+   begin
+      for I in Task_Events'First .. Task_Events_Index - 1 loop
+
+         TEST_SUPPORT.PUT_NAME(
+            SPTEST.TASK_NAME( Task_Events (I).Task_Index ), FALSE
+         );
+         TEST_SUPPORT.PRINT_TIME( "- ", Task_Events (I).When_Switched, "" );
+         TEXT_IO.NEW_LINE;
+
+      end loop;
+
+   end Flush_Task_Event_Log;
 
 --PAGE
@@ -230,7 +269,10 @@
             TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_MODE" );
 
-            LOOP
+            while not TestsFinished loop
                NULL;
             END LOOP;
+            Flush_Task_Event_Log;
+            TEXT_IO.PUT_LINE( "*** END OF TEST 4 ***" );
+            RTEMS.SHUTDOWN_EXECUTIVE( 0 );
 
          end if;
@@ -291,6 +333,5 @@
    begin
 
-      --INDEX := TEST_SUPPORT.TASK_NUMBER( HEIR.OBJECT.ID );
-      INDEX := TCB_To_ID( HEIR );
+      INDEX := TEST_SUPPORT.TASK_NUMBER( TCB_To_ID( HEIR ) );
 
       case INDEX is
@@ -301,11 +342,8 @@
             TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "CLOCK_GET" );
 
-            TEST_SUPPORT.PUT_NAME( SPTEST.TASK_NAME( INDEX ), FALSE );
-            TEST_SUPPORT.PRINT_TIME( "- ", TIME, "" );
-            TEXT_IO.NEW_LINE;
+            Log_Task_Event ( INDEX, TIME );
            
             if TIME.SECOND >= 16 then
-               TEXT_IO.PUT_LINE( "*** END OF TEST 4 ***" );
-               RTEMS.SHUTDOWN_EXECUTIVE( 0 );
+               TestsFinished := True;
             end if;
 
Index: c/src/ada-tests/sptests/sp05/config.h
===================================================================
--- c/src/ada-tests/sptests/sp05/config.h	(revision d14963bf948d6e7b9250cc077f86c18e6458b478)
+++ c/src/ada-tests/sptests/sp05/config.h	(revision ba3e1a4fafa6c5f1c1ad731d33c84e41ccba870b)
@@ -3,5 +3,5 @@
  *  This include file defines the Configuration Table for this test.
  *
- *  COPYRIGHT (c) 1989-1997.
+ *  COPYRIGHT (c) 1989-2007.
  *  On-Line Applications Research Corporation (OAR).
  *
@@ -30,4 +30,6 @@
 #define CONFIGURE_MAXIMUM_POSIX_CONDITION_VARIABLES  10
 
+#define CONFIGURE_MAXIMUM_TASKS             4
+
 #include <rtems/confdefs.h>
 
Index: c/src/ada-tests/sptests/sp06/config.h
===================================================================
--- c/src/ada-tests/sptests/sp06/config.h	(revision d14963bf948d6e7b9250cc077f86c18e6458b478)
+++ c/src/ada-tests/sptests/sp06/config.h	(revision ba3e1a4fafa6c5f1c1ad731d33c84e41ccba870b)
@@ -3,5 +3,5 @@
  *  This include file defines the Configuration Table for this test.
  *
- *  COPYRIGHT (c) 1989-1997.
+ *  COPYRIGHT (c) 1989-2007.
  *  On-Line Applications Research Corporation (OAR).
  *
@@ -30,4 +30,6 @@
 #define CONFIGURE_MAXIMUM_POSIX_CONDITION_VARIABLES  10
 
+#define CONFIGURE_MAXIMUM_TASKS             4
+
 #include <rtems/confdefs.h>
 
Index: c/src/ada-tests/sptests/sp07/config.h
===================================================================
--- c/src/ada-tests/sptests/sp07/config.h	(revision d14963bf948d6e7b9250cc077f86c18e6458b478)
+++ c/src/ada-tests/sptests/sp07/config.h	(revision ba3e1a4fafa6c5f1c1ad731d33c84e41ccba870b)
@@ -3,5 +3,5 @@
  *  This include file defines the Configuration Table for this test.
  *
- *  COPYRIGHT (c) 1989-1997.
+ *  COPYRIGHT (c) 1989-2007.
  *  On-Line Applications Research Corporation (OAR).
  *
@@ -31,4 +31,6 @@
 #define CONFIGURE_MAXIMUM_POSIX_CONDITION_VARIABLES  10
 
+#define CONFIGURE_MAXIMUM_TASKS             5
+
 #include <rtems/confdefs.h>
 
Index: c/src/ada-tests/sptests/sp07/sptest.adb
===================================================================
--- c/src/ada-tests/sptests/sp07/sptest.adb	(revision d14963bf948d6e7b9250cc077f86c18e6458b478)
+++ c/src/ada-tests/sptests/sp07/sptest.adb	(revision ba3e1a4fafa6c5f1c1ad731d33c84e41ccba870b)
@@ -11,5 +11,5 @@
 --  
 --
---  COPYRIGHT (c) 1989-1997.
+--  COPYRIGHT (c) 1989-2007.
 --  On-Line Applications Research Corporation (OAR).
 --
@@ -28,4 +28,87 @@
 
 package body SPTEST is
+
+      type Task_Event_Type is (
+         Created,
+         Deleted,
+         Restarted,
+         Started
+      );
+
+      type Task_Event is record
+         The_Event : Task_Event_Type;
+         Task1     : RTEMS.Unsigned32;
+         Task2     : RTEMS.Unsigned32;
+      end record;
+
+      Task_Events : array (1 .. 10) of Task_Event;
+      Task_Events_Index : Natural := Task_Events'First;
+
+      procedure Log_Task_Event (
+         The_Event : in     Task_Event_Type;
+         Task1     : in     RTEMS.Unsigned32;
+         Task2     : in     RTEMS.Unsigned32
+      ) is
+      begin
+         if Task_Events_Index = Task_Events'Last then
+            RTEMS.Fatal_Error_Occurred ( 1 );  -- no other choice
+         else
+            Task_Events (Task_Events_Index).The_Event := The_Event;
+            Task_Events (Task_Events_Index).Task1 := Task1;
+            Task_Events (Task_Events_Index).Task2 := Task2;
+            Task_Events_Index := Task_Events_Index + 1;
+         end if;
+      end Log_Task_Event;
+
+      procedure Flush_Task_Event_Log is
+      begin
+         for I in Task_Events'First .. Task_Events_Index - 1 loop
+
+            case Task_Events (I).The_Event is
+
+               when Created =>
+                  TEXT_IO.PUT( "TASKS_CREATE - " );
+                  TEST_SUPPORT.PUT_NAME( 
+                     SPTEST.TASK_NAME( Task_Events (I).Task1 ),
+                     FALSE
+                  );
+                  TEXT_IO.PUT_LINE( " - created." );
+
+               when Deleted =>
+                  TEXT_IO.PUT( "TASKS_DELETE - " );
+                  TEST_SUPPORT.PUT_NAME( 
+                     SPTEST.TASK_NAME( Task_Events (I).Task1 ),
+                     FALSE
+                  );
+
+                  TEXT_IO.PUT( " deleting " );
+                  TEST_SUPPORT.PUT_NAME( 
+                     SPTEST.TASK_NAME( Task_Events (I).Task2 ),
+                     TRUE
+                  );
+
+               when Restarted =>
+                  TEXT_IO.PUT( "TASKS_RESTART - " );
+                  TEST_SUPPORT.PUT_NAME( 
+                     SPTEST.TASK_NAME( Task_Events (I).Task1 ),
+                     FALSE
+                  );
+                  TEXT_IO.PUT_LINE( " - restarted." );
+
+               when Started =>
+                  TEXT_IO.PUT( "TASKS_START - " );
+                  TEST_SUPPORT.PUT_NAME( 
+                     SPTEST.TASK_NAME( Task_Events (I).Task1 ),
+                     FALSE
+                  );
+                  TEXT_IO.PUT_LINE( " - started." );
+
+            end case;
+         end loop;
+
+         -- Reset the events list
+         Task_Events_Index := Task_Events'First;
+
+      end Flush_Task_Event_Log;
 
 --PAGE
@@ -146,4 +229,6 @@
       RTEMS.TASK_RESTART( SPTEST.TASK_ID( 3 ), 0, STATUS );
       TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_RESTART OF TA3" );
+
+      Flush_Task_Event_Log;
 
       RTEMS.TASK_SET_NOTE( SPTEST.TASK_ID( 1 ), 8, 4, STATUS );
@@ -364,4 +449,6 @@
    begin
 
+      Flush_Task_Event_Log;
+
       TEXT_IO.PUT_LINE( "TA4 - exitting task" );
 
@@ -392,20 +479,19 @@
 --
 
-   procedure TASK_CREATE_EXTENSION (
+   function TASK_CREATE_EXTENSION (
       UNUSED       : in     RTEMS.TCB_POINTER;
       CREATED_TASK : in     RTEMS.TCB_POINTER
-   ) is
+   ) return RTEMS.Boolean is
    begin
 
       if TEST_SUPPORT.TASK_NUMBER( TCB_To_ID( CREATED_TASK ) ) > 0 then
-         TEXT_IO.PUT( "TASKS_CREATE - " );
-         TEST_SUPPORT.PUT_NAME( 
-            SPTEST.TASK_NAME( 
-               TEST_SUPPORT.TASK_NUMBER( TCB_To_ID( CREATED_TASK ) )
-            ),
-            FALSE
+         Log_Task_Event ( 
+            Created, 
+            TEST_SUPPORT.TASK_NUMBER( TCB_To_ID( CREATED_TASK ) ),
+            0
          );
-         TEXT_IO.PUT_LINE( "- created." );
       end if;
+
+      return RTEMS.True;
 
    end TASK_CREATE_EXTENSION;
@@ -422,21 +508,10 @@
    begin
 
-      if TEST_SUPPORT.TASK_NUMBER( TCB_To_ID( RUNNING_TASK ) ) > 0 then
-         TEXT_IO.PUT( "TASKS_DELETE - " );
-         TEST_SUPPORT.PUT_NAME( 
-            SPTEST.TASK_NAME( 
-               TEST_SUPPORT.TASK_NUMBER( TCB_To_ID( RUNNING_TASK ) ) 
-            ),
-            FALSE
-         );
-      end if;
-
-      if TEST_SUPPORT.TASK_NUMBER( TCB_To_ID( DELETED_TASK ) ) > 0 then
-         TEXT_IO.PUT( "deleting " );
-         TEST_SUPPORT.PUT_NAME( 
-            SPTEST.TASK_NAME( 
-               TEST_SUPPORT.TASK_NUMBER( TCB_To_ID( DELETED_TASK ) ) 
-            ),
-            TRUE
+      if TEST_SUPPORT.TASK_NUMBER( TCB_To_ID( RUNNING_TASK ) ) > 0 and
+        TEST_SUPPORT.TASK_NUMBER( TCB_To_ID( DELETED_TASK ) ) > 0 then
+         Log_Task_Event ( 
+            Deleted, 
+            TEST_SUPPORT.TASK_NUMBER( TCB_To_ID( RUNNING_TASK ) ),
+            TEST_SUPPORT.TASK_NUMBER( TCB_To_ID( DELETED_TASK ) )
          );
       end if;
@@ -456,12 +531,9 @@
 
       if TEST_SUPPORT.TASK_NUMBER( TCB_To_ID( RESTARTED_TASK ) ) > 0 then
-         TEXT_IO.PUT( "TASKS_RESTART - " );
-         TEST_SUPPORT.PUT_NAME( 
-            SPTEST.TASK_NAME( 
-               TEST_SUPPORT.TASK_NUMBER( TCB_To_ID( RESTARTED_TASK ) ) 
-            ),
-            FALSE
+         Log_Task_Event ( 
+            Restarted, 
+            TEST_SUPPORT.TASK_NUMBER( TCB_To_ID( RESTARTED_TASK ) ),
+            0
          );
-         TEXT_IO.PUT_LINE( " - restarted." );
       end if;
 
@@ -480,12 +552,9 @@
 
       if TEST_SUPPORT.TASK_NUMBER( TCB_To_ID( STARTED_TASK ) ) > 0 then
-         TEXT_IO.PUT( "TASKS_START - " );
-         TEST_SUPPORT.PUT_NAME( 
-            SPTEST.TASK_NAME( 
-               TEST_SUPPORT.TASK_NUMBER( TCB_To_ID( STARTED_TASK ) ) 
-            ),
-            FALSE
+         Log_Task_Event ( 
+            Started, 
+            TEST_SUPPORT.TASK_NUMBER( TCB_To_ID( STARTED_TASK ) ),
+            0
          );
-         TEXT_IO.PUT_LINE( " - started." );
       end if;
 
Index: c/src/ada-tests/sptests/sp07/sptest.ads
===================================================================
--- c/src/ada-tests/sptests/sp07/sptest.ads	(revision d14963bf948d6e7b9250cc077f86c18e6458b478)
+++ c/src/ada-tests/sptests/sp07/sptest.ads	(revision ba3e1a4fafa6c5f1c1ad731d33c84e41ccba870b)
@@ -11,5 +11,5 @@
 --  
 --
---  COPYRIGHT (c) 1989-1997.
+--  COPYRIGHT (c) 1989-2007.
 --  On-Line Applications Research Corporation (OAR).
 --
@@ -109,8 +109,8 @@
 --
 
-   procedure TASK_CREATE_EXTENSION (
+   function TASK_CREATE_EXTENSION (
       UNUSED       : in     RTEMS.TCB_POINTER;
       CREATED_TASK : in     RTEMS.TCB_POINTER
-   );
+   ) return RTEMS.Boolean;
 
 --
Index: c/src/ada-tests/sptests/sp08/config.h
===================================================================
--- c/src/ada-tests/sptests/sp08/config.h	(revision d14963bf948d6e7b9250cc077f86c18e6458b478)
+++ c/src/ada-tests/sptests/sp08/config.h	(revision ba3e1a4fafa6c5f1c1ad731d33c84e41ccba870b)
@@ -3,5 +3,5 @@
  *  This include file defines the Configuration Table for this test.
  *
- *  COPYRIGHT (c) 1989-1997.
+ *  COPYRIGHT (c) 1989-2007.
  *  On-Line Applications Research Corporation (OAR).
  *
@@ -30,4 +30,6 @@
 #define CONFIGURE_MAXIMUM_POSIX_CONDITION_VARIABLES  10
 
+#define CONFIGURE_MAXIMUM_TASKS             2
+
 #include <rtems/confdefs.h>
 
Index: c/src/ada-tests/sptests/sp08/sp08.scn
===================================================================
--- c/src/ada-tests/sptests/sp08/sp08.scn	(revision d14963bf948d6e7b9250cc077f86c18e6458b478)
+++ c/src/ada-tests/sptests/sp08/sp08.scn	(revision ba3e1a4fafa6c5f1c1ad731d33c84e41ccba870b)
@@ -1,20 +1,20 @@
 *** TEST 8 ***
-TA1 - task_mode - ASR                  - previous mode:     16#0#
-TA1 - task_mode - NO_ASR               - previous mode:     16#0#
-TA1 - task_mode - NO_ASR               - previous mode:   16#400#
-TA1 - task_mode - ASR                  - previous mode:   16#400#
-TA1 - task_mode - NO_TIMESLICE         - previous mode:     16#0#
-TA1 - task_mode - TIMESLICE            - previous mode:     16#0#
-TA1 - task_mode - TIMESLICE            - previous mode:   16#200#
-TA1 - task_mode - NO_TIMESLICE         - previous mode:   16#200#
-TA1 - task_mode - PREEMPT              - previous mode:     16#0#
-TA1 - task_mode - NO_PREEMPT           - previous mode:     16#0#
-TA1 - task_mode - NO_PREEMPT           - previous mode:   16#100#
-TA1 - task_mode - PREEMPT              - previous mode:   16#100#
-TA1 - task_mode - INTERRUPT_LEVEL( 3 ) - previous mode:     16#0#
-TA1 - task_mode - INTERRUPT_LEVEL( 5 ) - previous mode:     16#3#
-TA1 - task_mode - set all modes        - previous mode:     16#5#
-TA1 - task_mode - set all modes        - previous mode:   16#703#
-TA1 - task_mode - clear all modes      - previous mode:   16#703#
-TA1 - task_mode - get current mode     - previous mode:     16#0#
+TA1 - task_mode - ASR                  - previous mode:    16#0#
+TA1 - task_mode - NO_ASR               - previous mode:    16#0#
+TA1 - task_mode - NO_ASR               - previous mode:  16#400#
+TA1 - task_mode - ASR                  - previous mode:  16#400#
+TA1 - task_mode - NO_TIMESLICE         - previous mode:    16#0#
+TA1 - task_mode - TIMESLICE            - previous mode:    16#0#
+TA1 - task_mode - TIMESLICE            - previous mode:  16#200#
+TA1 - task_mode - NO_TIMESLICE         - previous mode:  16#200#
+TA1 - task_mode - PREEMPT              - previous mode:    16#0#
+TA1 - task_mode - NO_PREEMPT           - previous mode:    16#0#
+TA1 - task_mode - NO_PREEMPT           - previous mode:  16#100#
+TA1 - task_mode - PREEMPT              - previous mode:  16#100#
+TA1 - task_mode - INTERRUPT_LEVEL( 3 ) - previous mode:    16#0#
+TA1 - task_mode - INTERRUPT_LEVEL( 5 ) - previous mode:    16#1#
+TA1 - task_mode - set all modes        - previous mode:    16#1#
+TA1 - task_mode - set all modes        - previous mode:  16#701#
+TA1 - task_mode - clear all modes      - previous mode:  16#701#
+TA1 - task_mode - get current mode     - previous mode:    16#0#
 *** END OF TEST 8 ***
Index: c/src/ada-tests/sptests/sp09/Makefile.am
===================================================================
--- c/src/ada-tests/sptests/sp09/Makefile.am	(revision d14963bf948d6e7b9250cc077f86c18e6458b478)
+++ c/src/ada-tests/sptests/sp09/Makefile.am	(revision ba3e1a4fafa6c5f1c1ad731d33c84e41ccba870b)
@@ -5,4 +5,8 @@
 
 include $(top_srcdir)/ada.am
+
+# Prevents Ada from raising a constraint so that the error
+# handling can be verified in the binding.
+AM_ADAFLAGS += -gnatp
 
 noinst_PROGRAMS = sp09
Index: c/src/ada-tests/sptests/sp09/config.h
===================================================================
--- c/src/ada-tests/sptests/sp09/config.h	(revision d14963bf948d6e7b9250cc077f86c18e6458b478)
+++ c/src/ada-tests/sptests/sp09/config.h	(revision ba3e1a4fafa6c5f1c1ad731d33c84e41ccba870b)
@@ -3,5 +3,5 @@
  *  This include file defines the Configuration Table for this test.
  *
- *  COPYRIGHT (c) 1989-1997.
+ *  COPYRIGHT (c) 1989-2007.
  *  On-Line Applications Research Corporation (OAR).
  *
@@ -21,4 +21,5 @@
 #define CONFIGURE_APPLICATION_NEEDS_CLOCK_DRIVER
 
+#define CONFIGURE_MAXIMUM_TASKS              10
 #define CONFIGURE_MAXIMUM_TIMERS              1
 #define CONFIGURE_MAXIMUM_SEMAPHORES          2
